import { Component, Input, ElementRef, ViewChild, Renderer } from '@angular/core';
var DimmerComponent = (function () {
    function DimmerComponent(_renderer) {
        this._renderer = _renderer;
    }
    Object.defineProperty(DimmerComponent.prototype, "active", {
        get: function () {
            return this._active;
        },
        set: function (val) {
            this._active = val;
            this.toggleDimmer();
        },
        enumerable: true,
        configurable: true
    });
    DimmerComponent.prototype.ngAfterViewInit = function () {
        if (!this.parentEle) {
            this.parentEle = this.dimmerDiv.nativeElement.parentElement.parentElement;
        }
        this.toggleDimmer();
    };
    DimmerComponent.prototype.toggleDimmer = function () {
        if (!this.parentEle)
            return;
        this._renderer.setElementClass(this.parentEle, 'dimmable', this.active);
        this._renderer.setElementClass(this.parentEle, 'dimmed', this.active);
    };
    DimmerComponent.prototype.show = function () {
        this.active = true;
        this.toggleDimmer();
    };
    DimmerComponent.prototype.hide = function () {
        this.active = false;
        this.toggleDimmer();
    };
    DimmerComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lsu-dimmer',
                    template: "\n    <div #dimmerDiv class=\"ui dimmer\" [ngClass]=\"{'active': active}\">\n      <div class=\"content\">\n        <div class=\"center\">\n          <ng-content></ng-content>\n        </div>\n      </div>\n    </div>\n  "
                },] },
    ];
    /** @nocollapse */
    DimmerComponent.ctorParameters = function () { return [
        { type: Renderer, },
    ]; };
    DimmerComponent.propDecorators = {
        "dimmerDiv": [{ type: ViewChild, args: ["dimmerDiv",] },],
        "active": [{ type: Input },],
    };
    return DimmerComponent;
}());
export { DimmerComponent };
//# sourceMappingURL=dimmer.component.js.map