import { Component, Input, ViewChild, ElementRef, Renderer } from '@angular/core';
var ModalComponent = (function () {
    function ModalComponent(_renderer) {
        this._renderer = _renderer;
        this.options = {};
    }
    ModalComponent.prototype.ngOnInit = function () {
    };
    ModalComponent.prototype.ngAfterViewInit = function () {
        this._renderer.setElementClass(document.body, 'dimmable', true);
        this.element = this.modalContent.nativeElement;
    };
    ModalComponent.prototype.show = function () {
        var _this = this;
        this._renderer.setElementClass(document.body, 'dimmed', true);
        setTimeout(function () {
            var windowHeight = document.body.offsetHeight;
            var eleHeight = _this.element.offsetHeight;
            var top = (windowHeight - eleHeight) / 2;
            _this.element.style.top = top + 'px';
            _this.actived = true;
        });
    };
    ModalComponent.prototype.hide = function () {
        this.actived = false;
        this._renderer.setElementClass(document.body, 'dimmed', false);
    };
    ModalComponent.prototype._clickContent = function (event) {
        event.stopPropagation();
    };
    ModalComponent.prototype._closeModal = function () {
        if (!this.options.closeable) {
            return;
        }
        this.hide();
    };
    ModalComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lsu-modal',
                    styles: [
                        " .trans-fadeout{\n        -webkit-transition:all 0.3s linear;\n        -moz-transition:all 0.3s linear;\n        -ms-transition:all 0.3s linear;\n        -o-transition:all 0.3s linear;\n        transition:all 0.3s linear;\n      }\n    "
                    ],
                    template: "\n    <div class=\"ui dimmer modals page trans-fadeout\" style=\"display: block !important\"\n      [style.visibility] = \"actived ? 'visible' : 'hidden'\"\n      [style.opacity] = \"actived ? '1' : '0'\"\n      (click)=\"_closeModal()\">\n      <div #modalContent class=\"ui {{options.size || ''}} {{options.type || ''}} modal active visibility\" (click)=\"_clickContent($event)\">\n        <ng-content></ng-content>\n      </div>\n    </div>\n  "
                },] },
    ];
    /** @nocollapse */
    ModalComponent.ctorParameters = function () { return [
        { type: Renderer, },
    ]; };
    ModalComponent.propDecorators = {
        "options": [{ type: Input },],
        "modalContent": [{ type: ViewChild, args: ['modalContent',] },],
    };
    return ModalComponent;
}());
export { ModalComponent };
//# sourceMappingURL=modal.component.js.map