import { Component, Input, forwardRef } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
var RatingComponent = (function () {
    function RatingComponent() {
        this._maxRating = 1;
        this.rating = 0;
        this.type = "star";
        this.size = "";
        this._onChange = function (_) { };
        this._onTouched = function () { };
    }
    Object.defineProperty(RatingComponent.prototype, "maxRating", {
        get: function () {
            return this._maxRating;
        },
        set: function (val) {
            this._maxRating = val;
            if (this.rating > val) {
                this.setRating(val);
            }
            this.ratings = this.getRatings(val);
        },
        enumerable: true,
        configurable: true
    });
    RatingComponent.prototype.writeValue = function (value) {
        this.rating = value;
        this._onChange(value);
    };
    RatingComponent.prototype.registerOnChange = function (fn) {
        this._onChange = fn;
    };
    RatingComponent.prototype.registerOnTouched = function (fn) {
        this._onTouched = fn;
    };
    RatingComponent.prototype.ngOnInit = function () {
        this.type = this.type.toLowerCase();
        this.size = this.size.toLowerCase();
        this.ratings = this.getRatings(this.maxRating);
    };
    RatingComponent.prototype.getRatings = function (size) {
        var ratings = [];
        for (var i = 0; i < size; i++) {
            ratings.push(i + 1);
        }
        return ratings;
    };
    RatingComponent.prototype.setRating = function (item) {
        this.writeValue(item);
    };
    RatingComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lsu-rating',
                    template: "\n    <div class=\"ui {{ type }} {{ size }} rating\">\n      <i class=\"icon\" *ngFor=\"let item of ratings\" [ngClass]=\"{'active': item <= rating }\" (click)=\"setRating(item)\"></i>\n    </div>\n  ",
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(function () { return RatingComponent; }),
                            multi: true
                        }]
                },] },
    ];
    /** @nocollapse */
    RatingComponent.ctorParameters = function () { return []; };
    RatingComponent.propDecorators = {
        "maxRating": [{ type: Input },],
        "rating": [{ type: Input },],
        "type": [{ type: Input },],
        "size": [{ type: Input },],
    };
    return RatingComponent;
}());
export { RatingComponent };
//# sourceMappingURL=rating.component.js.map