import { Component, Input, ElementRef, forwardRef, ViewChild } from '@angular/core';
import { NG_VALUE_ACCESSOR } from '@angular/forms';
var TagsInputComponent = (function () {
    function TagsInputComponent() {
        this.placeholder = 'Add Tag';
        this.invalidMsg = 'Value is invalid';
        this.tags = [];
        this.isBackspaceDown = false;
        this.submitted = false;
        this._onChange = function (_) { };
        this._onTouched = function () { };
    }
    TagsInputComponent.prototype.ngOnInit = function () {
    };
    TagsInputComponent.prototype.ngAfterViewInit = function () {
        if (!this.rootEle) {
            this.rootEle = this.rootEleRef.nativeElement;
        }
    };
    TagsInputComponent.prototype.writeValue = function (value) {
        this.tags = value || [];
        this._onChange(this.tags);
    };
    TagsInputComponent.prototype.registerOnChange = function (fn) {
        this._onChange = fn;
    };
    TagsInputComponent.prototype.registerOnTouched = function (fn) {
        this._onTouched = fn;
    };
    TagsInputComponent.prototype.topKeyup = function (event) {
        if (event.keyCode === 8 && this.delTarget) {
            var index = this.tags.indexOf(this.delTarget);
            if (index !== -1) {
                this.tags.splice(index, 1);
            }
            this.delTarget = '';
        }
    };
    TagsInputComponent.prototype.setDeltarget = function (tag, evnet) {
        this.delTarget = tag;
        event.stopPropagation();
    };
    TagsInputComponent.prototype.remove = function (index, evnet) {
        this.tags.splice(index, 1);
        event.stopPropagation();
    };
    TagsInputComponent.prototype.tagInputOnFocus = function (event) {
        this.submitted = !!event.srcElement.value;
        this.delTarget = '';
    };
    TagsInputComponent.prototype.tagInputKeyPress = function (event) {
        var value = event.srcElement.value;
        if (event.keyCode === 13 && value) {
            this.submitted = true;
            if (this.tags.indexOf(value) === -1) {
                this.tags.push(value);
            }
            event.srcElement.value = '';
            this.submitted = false;
            event.preventDefault();
        }
    };
    TagsInputComponent.prototype.tagInputKeyDown = function (event) {
        var value = event.srcElement.value;
        if (event.keyCode === 8 && !value) {
            this.isBackspaceDown = true;
        }
        else {
            this.isBackspaceDown = false;
        }
    };
    TagsInputComponent.prototype.tagInputKeyUp = function (event) {
        var value = event.srcElement.value;
        if (event.keyCode === 8 && !value && this.tags.length > 0 && this.isBackspaceDown) {
            this.delTarget = this.tags[this.tags.length - 1];
            event.stopPropagation();
            this.rootEle.focus();
        }
    };
    TagsInputComponent.decorators = [
        { type: Component, args: [{
                    selector: 'lsu-tagsInput',
                    styles: [".tags-input.invalid { border-top: 2px solid #DB2828 !important; } .tags-input .ui.label.transition.visible { height: 25px; display: inline-block !important; } .tags-input .ui.input { display: inline-block; width: auto; } .tags-input .ui.input input { height: 30px; padding: 0 5px; border: none; } .tags-input .ui.input input:focus { border-radius: inherit; } .deleteTarget:hover, .deleteTarget { border: 0 solid tomato; background-color: tomato !important; color: white !important; } "],
                    template: "<div #rootEleRef class=\"ui fluid dropdown selection multiple tags-input\" tabindex=\"-1\" (click)=\"tagsInput.focus()\" (keyup)=\"topKeyup($event)\"> <a class=\"ui label transition visible\" [class.deleteTarget]=\"delTarget == tag\" *ngFor=\"let tag of tags; let i = index; let last = last;\" (click)=\"setDeltarget(tag, $event)\"> {{ tag }} <i class=\"delete icon\" (click)=\"remove(i, $event)\"></i> </a> <div class=\"ui input\"> <input type=\"text\" autocomplete=\"off\" [attr.placeholder]=\"placeholder\" #tagsInput (focus)=\"tagInputOnFocus($event)\" (keyup)=\"tagInputKeyUp($event)\" (keydown)=\"tagInputKeyDown($event)\" (keypress)=\"tagInputKeyPress($event)\"> </div> </div> ",
                    providers: [{
                            provide: NG_VALUE_ACCESSOR,
                            useExisting: forwardRef(function () { return TagsInputComponent; }),
                            multi: true
                        }]
                },] },
    ];
    /** @nocollapse */
    TagsInputComponent.ctorParameters = function () { return []; };
    TagsInputComponent.propDecorators = {
        "rootEleRef": [{ type: ViewChild, args: ['rootEleRef',] },],
        "placeholder": [{ type: Input },],
        "invalidMsg": [{ type: Input },],
    };
    return TagsInputComponent;
}());
export { TagsInputComponent };
//# sourceMappingURL=tags-input.component.js.map